#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct hrana {
	int u;
	int v;
	int d;
} hrany[2500000];

int cmph(const void *a, const void *b) {
	hrana *aa = (hrana*)a;
	hrana *bb = (hrana*)b;

	if(aa->d > bb->d) return 1;
	else if(aa->d == bb->d) return 0;
	else return -1;
}

char trucks[2001][8];

int get_d(int t1, int t2) {
	int i=0;
	int d=0;
	for(i=0; i<7; i++) {
		if(trucks[t1][i] != trucks[t2][i]) d++;
	}
	return d;
}

int N;
int uzly[2001];
int available, zapojeno;

int main(void) {
	int i, j, h;
	hrana *hh;
	int Q;
	
	while(1) {
		scanf("%d", &N);
		if(N == 0) return 0;
		
		for(i=0; i<N; i++) {
			scanf("%s", trucks[i]);
		}

		//seznam hran vytvorit
		h = 0;
		for(i=1; i<N; i++) {
			for(j=0; j<i; j++) {
				hrany[h].u = i;
				hrany[h].v = j;
				hrany[h].d = get_d(i,j);
				h++;
			}
		}
		
		//seznam uzlu inicializovat
		memset(uzly, 0, sizeof(int)*2001);

		//seznam hran setridit
		qsort(hrany, h, sizeof(hrana), cmph);

		//a makej!
		zapojeno = 0;
		available = 1;
		Q = 0;
		for(i=0; i<h; i++) {
			hh = &hrany[i];
			if(uzly[hh->u] == 0 && uzly[hh->v] == 0) {		
				Q += hh->d;
				uzly[hh->u] = available;
				uzly[hh->v] = available;
				available++;
				zapojeno++;
			} else if(uzly[hh->u] == 0) {
				Q += hh->d;
				uzly[hh->u] = uzly[hh->v];
				zapojeno++;
			} else if(uzly[hh->v] == 0) {
				Q += hh->d;
				uzly[hh->v] = uzly[hh->u];
				zapojeno++;
			} else if(uzly[hh->v] != uzly[hh->u]) {
				Q += hh->d;
				zapojeno++;
				for(j=0; j<N; j++) {
					if(uzly[j] == uzly[hh->u]) {
						uzly[j] = uzly[hh->u];
					}
				}
			}

			if( zapojeno == N-1 ) break;
		} /* for */
			
		printf("The highest possible quality is 1/%d.\n",Q);
				
		
	}
}

