#include<stdio.h>
#include<stdlib.h>

struct point {
	int x;
	int y;
} pole[100001];

int compxy(const void *a, const void *b) {
	point *aa = (point *)a;
	point *bb = (point *)b;

	if(aa->x < bb->x) return -1;
	else if(aa->x > bb->x) return 1;
	else {
		if(aa->y < bb->y) return -1;
		else if(aa->y > bb->y) return 1;
		else return 0;
	}
}
void out(int P) {
	for(int i=0; i<P; i++) {
		printf("(%d, %d)\n",pole[i].x, pole[i].y);
	}
}

int compyx(const void *a, const void *b) {
	point *aa = (point *)a;
	point *bb = (point *)b;

	if(aa->y < bb->y) return -1;
	else if(aa->y > bb->y) return 1;
	else {
		if(aa->x < bb->x) return -1;
		else if(aa->x > bb->x) return 1;
		else return 0;
	}
}


int main(void) {
	int P;
	int i;
	int L;

	scanf("%d", &P);
	while(P) {
		if(P == 1) {
			printf("The length of the fence will be 0 units.\n");
			scanf("%d", &P);
			continue;
		}
		
		L = 0;	
		
		for(i=0; i<P; i++) {
			scanf("%d %d", &pole[i].x, &pole[i].y);
		}
	//	out(P);

		//sort by x, y
		qsort(pole, P, sizeof(point), compxy);
		//out(P);

		for(i=0; i<P; i+=2) {
			L += pole[i+1].y - pole[i].y;
		}

		//sort by y, x
		qsort(pole, P, sizeof(point), compyx);
		for(i=0; i<P; i+=2) {
			L += pole[i+1].x - pole[i].x;
		}
		
		printf("The length of the fence will be %d units.\n", L);
		
		scanf("%d", &P);
	}

	return 0;
}

